#!/usr/bin/perl

use strict;

my $TIME = '/usr/bin/time';

my $cmd = [ { name => 'Java int',
	      cmd => "javac -Xlint hw0.java && $TIME java -cp . hw0 2>&1",
	    },
	    { name => 'Java Integer',
	      cmd => "javac -Xlint hw0Integer.java && $TIME java -cp . hw0Integer 2>&1",
	    },
	    { name => 'Java Integer Integer',
	      cmd => "javac -Xlint hw0IntegerInteger.java && $TIME java -cp . hw0IntegerInteger 2>&1",
	    },
	    { name => 'C',
	      cmd => "gcc -Wall hw0.c && $TIME ./a.out 2>&1",
	    },
	    { name => 'Optimized C',
	      cmd => "gcc -Wall -O2 hw0.c && $TIME ./a.out 2>&1",
	    },
	  ];

foreach my $entry (@{$cmd}) {
  open(my $fh, "$entry->{cmd}|") || die "Couldn't open '$entry->{cmd}'";
  my $totalTime = 0;
  while (<$fh>) {
    $totalTime += $1 if m/(\d+\.\d+)user/;
    $totalTime += $1 if m/(\d+\.\d+)system/;
  }
  close($fh);
  print sprintf("%20s  %f\n", $entry->{name}, $totalTime);
}
